#ifndef FIR_FILTER_H
#define	FIR_FILTER_H

#include <xc.h>
#include <stdint.h>


#define FIR_FILTER_LENGTH 25

typedef struct
{
    float x[FIR_FILTER_LENGTH];
    uint8_t index;
    float y;
    float h[FIR_FILTER_LENGTH];
}FIRfilter_t;

void FIRfilter_Init(FIRfilter_t *filter, const float *coeff);
void FIRFilter_FilterSignal(FIRfilter_t *filter, float x);

#endif	

