#include <xc.h>
#include <string.h>
#include "FIRfilter_fp.h"

void FIRfilter_Init_fp(FIRfilter_fp_t *filter, fix *coeff)
{
    for(uint8_t i=0; i<FIR_FILTER_LENGTH; i++)
    {
        filter->x[i] = 0;
    }
        filter->index = 0;
        filter->y = 0;
        
        memcpy(filter->h, coeff, FIR_FILTER_LENGTH*sizeof(fix));
}

void FIRFilter_FilterSignal_fp(FIRfilter_fp_t *filter, fix x)
{
    filter->y = 0;
    
    filter->x[filter->index] = x;
    
    uint8_t j = filter->index;
    
    filter->index++;
    if(filter->index == FIR_FILTER_LENGTH)
    {
        filter->index = 0;
    }
    
    for(uint8_t i=0; i<FIR_FILTER_LENGTH; i++)
    {
        if(j>0)
        {
            j--;
        }
        else
        {
            j = FIR_FILTER_LENGTH-1;
        }
         filter->y = fp_sum(filter->y, fp_mul(filter->h[i],filter->x[j]));
    }
}