 #ifndef FIR_FILTER_H
#define	FIR_FILTER_H

#include <xc.h> 
#include <stdint.h>
#include "fixed_point.h"

#define FIR_FILTER_LENGTH 25

typedef struct
{
    fix x[FIR_FILTER_LENGTH];
    uint8_t index;
    fix y;
    fix h[FIR_FILTER_LENGTH];
}FIRfilter_fp_t;

void FIRfilter_Init_fp(FIRfilter_fp_t *filter, fix *coeff);
void FIRFilter_FilterSignal_fp(FIRfilter_fp_t *filter, fix x);


#endif	
