#ifndef FIXED_POINT_H
#define	FIXED_POINT_H

#include <xc.h> 

typedef int16_t fix;
typedef int32_t fix2;

#define FRAC 12

// Q3.12
#define fp2float(x) (float)x/((float)(1<<FRAC)) 
#define float2fp(x) (fix)(x*((float)(1<<FRAC))+0.5)


#define fp_sum(x, y)  ((x)+(y)) 
#define fp_sub(x, y)  ((x)-(y))
#define fp_mul(x, y)  (fix)(((fix2)(x)*(fix2)(y))>>FRAC)
#define fp_div(x, y)  (fix)(((fix2)(x)<<FRAC)/(y))

#endif	
